#include<assert.h>
#include<stdlib.h>
#include"file_hdl.h"
#include"tree_hdl.h"
#include"stree.h"

/* Canonizes transition state,(bgin,end). New state is returned and new 
   begin is placed to *new. */
st_node *canonize(st_meta *data,long *new, st_node *state,long bgin,long end)
{
  st_trans *ntrans;
  byte t;

  if(end>=bgin) {
    t=read_tchar(data,bgin);
    ntrans=get_transition(data,state,t);

    assert(ntrans!=NULL);

    while((ntrans->end-ntrans->begin)<=(end-bgin)) {
      bgin=bgin+ntrans->end-ntrans->begin+1;
      assert(ntrans->childs!=NULL);
      state=ntrans->childs;
      if(bgin<=end) {
	t=read_tchar(data,bgin);
	ntrans=get_transition(data,state,t);
	if(ntrans==NULL) {
	  fprintf(stderr,"ASSERTION FAILED!\n\n");
	  print_tree(data);
	}

	assert(ntrans!=NULL);
      }
    }
  }

  *new=bgin;
  return state;
}

/* returns NULL for true and valid pointer for false. */

st_node *test_and_split(st_meta *data,st_node *actv,long bgin,long end,byte t)
{
  byte other_t;
  st_trans *sdot;
  st_node *nnode;

  if(bgin<=end) {
    /* Propably redundant seek. */

    other_t=read_tchar(data,bgin);
    sdot=get_transition(data,actv,other_t);

    assert(sdot!=NULL);

    other_t=read_tchar(data,sdot->begin+end-bgin+1);

    if(t==other_t) {
      return NULL;
    } else {
      /* Split the transition to two. */
      nnode=malloc(sizeof(st_node));
      if(nnode==NULL) {
	mem_error();
      }

      nnode->n_tran=1;

      nnode->trans=malloc(sizeof(st_trans));
      if(nnode->trans==NULL) {
	mem_error();
      }

      nnode->trans[0].childs=sdot->childs;
      nnode->trans[0].end=sdot->end;
      nnode->trans[0].begin=sdot->begin+end-bgin+1;
      nnode->trans[0].transId=other_t;

      sdot->end=sdot->begin+end-bgin;
      sdot->childs=nnode;

      return nnode;
    }
  } else if(get_transition(data,actv,t)==NULL) {
    return actv;
  } else {
    return NULL;
  }
}

/* Updates stree for string of length end-1 to stree for string of length end.
   returns new active point and places new k in new. (to be passed to canonize)
*/
st_node *update(st_meta *data,long *new, st_node *state,long bgin,long end,byte t)
{
  st_node *r,*oldr=&(data->root);
  st_trans ntrans;

  r=test_and_split(data,state,bgin,end-1,t);

  while(r!=NULL) {
    /* create new transition g'(s,(i,inf))=r' where r' is a new state */
    ntrans.transId=t;
    ntrans.childs=NULL;
    ntrans.begin=end;
    ntrans.end=INFTY_P;
    insert_transition(data,r,&ntrans);

    if(oldr!=&(data->root)) {
      oldr->sfx_link=r;
    }

    oldr=r;

    state=canonize(data,&bgin,state->sfx_link,bgin,end-1);
    r=test_and_split(data,state,bgin,end-1,t);
  }
  if(oldr!=&(data->root)) {
    oldr->sfx_link=state;
  }

  *new=bgin;
  return state;
}

void create_stree(st_meta *data)
{
  long i,bgin=0;
  char t=1;
  st_node *actv=&(data->root);

  actv->sfx_link=NULL;

  for(i=0;t!=0;i++) {
    t=read_tchar(data,i);
    actv=update(data,&bgin,actv,bgin,i,t);
    actv=canonize(data,&bgin,actv,bgin,i);
  }
}




